package com.jasamedika.medifirst2000.service.impl;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.stereotype.Service;

import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.dao.BentukProdukDao;
import com.jasamedika.medifirst2000.entities.BentukProduk;
import com.jasamedika.medifirst2000.entities.Departemen;
import com.jasamedika.medifirst2000.entities.KelompokProduk;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.BentukProdukService;
import com.jasamedika.medifirst2000.vo.BentukProdukVO;
import com.jasamedika.medifirst2000.vo.DepartemenVO;
import com.jasamedika.medifirst2000.vo.KelompokProdukVO;

@Service("BentukProdukService")
public class BentukProdukServiceImpl extends BaseVoServiceImpl implements BentukProdukService{

	@Autowired
	private BentukProdukDao bentukProdukDao;
	
	@Autowired
	private BaseVoConverter<BentukProdukVO, BentukProduk> bentukProdukConverter;
	
	@Autowired
	private BaseVoConverter<DepartemenVO, Departemen> departementConverter;
	
	@Autowired BaseVoConverter<KelompokProdukVO, KelompokProduk> kelompokProdukConverter;

	@Override
	public BentukProdukVO add(BentukProdukVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public BentukProdukVO update(BentukProdukVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public Boolean delete(Integer key) throws JpaSystemException {
		return null;
	}

	@Override
	public BentukProdukVO findById(Integer key) throws JpaSystemException {
		return null;
	}

	@Override
	public List<BentukProdukVO> findAll() throws JpaSystemException {
		return null;
	}

	@Override
	public Map<String, Object> findAllWithPageAndLimitAndSortByAndDirectionParameter(Integer page, Integer limit,
			String sort, String dir) {
		return null;
	}

	@Override
	public Map<String, Object> findAll(Integer page, Integer take, String sort, String dir,
			Specification<BentukProduk> spec) {
		Direction direction=null;
		
		if(dir.equalsIgnoreCase("asc")){
			direction=Sort.Direction.ASC;
		}else{
			direction=Sort.Direction.DESC;
		}
		
		Pageable pageable = new PageRequest(page, take, direction, sort);
		Page<BentukProduk> resultPage = bentukProdukDao.findAll(spec, pageable);
		List<BentukProduk> resultData = resultPage.getContent();
		return constructMapReturn(resultData, resultPage.getTotalElements(), resultPage.getTotalPages());
	}

	@Override
	public Map<String, Object> save(BentukProdukVO vo) {
		Map<String,Object> result = new HashMap<String,Object>();
		BentukProduk model = bentukProdukConverter.transferVOToModel(vo, new BentukProduk());
		model.setDepartemen(departementConverter.transferVOToModel(vo.getDepartemen(), new Departemen()));
		model.setKelompokProduk(kelompokProdukConverter.transferVOToModel(vo.getKelompokProduk(), new KelompokProduk()));
		bentukProdukDao.save(model);
		
		return result;
	}

	@Override
	public Map<String, Object> getBentukProduk(String inputKode) {
		Map<String,Object> result = new HashMap<String,Object>();
		List<String> idBentukGizi = Arrays.asList(GetSettingDataFixed(inputKode).split(","));
		List<Integer> id = new ArrayList<Integer>();
		for(String idBentuk : idBentukGizi){
			id.add(Integer.parseInt(idBentuk));
		}
		result.put("data", bentukProdukDao.getBentukProdukGizi(id));
		return result;
	}

	@Override
	public Map<String, Object> getBentukProdukGizi() {
		Map<String, Object> result = new HashMap<>();
		result.put("data", this.bentukProdukDao.getAllProdukGizi());
		return result;
	}
	
	
	
	
}
